import dds
import ddsutil
import std_msgs/msg/Header_.std_msgs.msg.dds_
import struct

class CompressedImage___TypeSupport(dds.TypeSupport):

    _typename = 'sensor_msgs::msg::dds_::CompressedImage_'
    _keylist = ''
    _metadescriptor = '<MetaData version="1.0.0"><Module name="builtin_interfaces"><Module name="msg"><Module name="dds_"><Struct name="Time_"><Member name="sec_"><Long/></Member><Member name="nanosec_"><ULong/></Member></Struct></Module></Module></Module><Module name="std_msgs"><Module name="msg"><Module name="dds_"><Struct name="Header_"><Member name="stamp_"><Type name="::builtin_interfaces::msg::dds_::Time_"/></Member><Member name="frame_id_"><String/></Member></Struct></Module></Module></Module><Module name="sensor_msgs"><Module name="msg"><Module name="dds_"><Struct name="CompressedImage_"><Member name="header_"><Type name="::std_msgs::msg::dds_::Header_"/></Member><Member name="format_"><String/></Member><Member name="data_"><Sequence><Octet/></Sequence></Member></Struct></Module></Module></Module></MetaData>'

    def __init__(self):
        super(CompressedImage___TypeSupport, self).__init__(self._typename,
              self._keylist,
              self._metadescriptor,
              struct.calcsize(CompressedImage_()._get_packing_fmt()))

    def _serialize(self, o):
        if not isinstance(o, CompressedImage_):
            raise TypeError('Incorrect data type')
        result = o._serialize()
        return result

    def _deserialize(self, buf):
        result = CompressedImage_()
        data = struct.unpack(result._get_packing_fmt(), buf)
        result._deserialize(list(data))
        return result

class CompressedImage_(ddsutil.TopicDataClass):

    @staticmethod
    def get_type_support():
        ''' Return type support information required for dds.Topic constructor '''
        return CompressedImage___TypeSupport()

    @property
    def header_(self):
        '''
        a DDS std_msgs::msg::dds_::Header_ value
        @rtype: std_msgs/msg/Header_.std_msgs.msg.dds_.Header_
        '''
        return self._header__

    _header__checker = ddsutil._class_checker(std_msgs/msg/Header_.std_msgs.msg.dds_.Header_)
    @header_.setter
    def header_(self, value):
        self._header__checker(value)
        self._header__ = value

    @property
    def format_(self):
        '''
        a DDS string value
        @rtype: str
        '''
        return self._format__

    _format__checker = ddsutil._str_checker
    @format_.setter
    def format_(self, value):
        self._format__checker(value)
        self._format__ = value

    @property
    def data_(self):
        '''
        a DDS sequence<octet> value
        @rtype: list
        '''
        return self._data__

    _data__checker = ddsutil._seq_checker(0,ddsutil._octet_checker)
    @data_.setter
    def data_(self, value):
        self._data__checker(value)
        self._data__ = value

    _member_attributes = ('header_', 'format_', 'data_')

    def __init__(self, **kwargs):
        ''' Create a CompressedImage_ instance, optionally initializing fields by name '''
        # init attributes to default value
        self.header_ = std_msgs/msg/Header_.std_msgs.msg.dds_.Header_()
        self.format_ = ''
        self.data_ = []
        # set values for attributes passed in
        for key, value in kwargs.items():
            if key not in self._member_attributes:
                raise TypeError('Invalid argument name : %s' %(key))
            setattr(self, key, value)

    _packing_fmt = None

    @staticmethod
    def _get_packing_fmt():
        ''' Returns packing format of this class data '''
        if CompressedImage_._packing_fmt is not None:
            return CompressedImage_._packing_fmt
        fmt = ''
        fmt += ddsutil._align(fmt, std_msgs/msg/Header_.std_msgs.msg.dds_.Header_._get_packing_fmt())
        fmt += 'P'
        fmt += ddsutil._align(fmt, ddsutil._pad_fmt('iiP?'))

        CompressedImage_._packing_fmt = ddsutil._pad_fmt(fmt)
        return CompressedImage_._packing_fmt

    def _serialize(self):
        ''' Serialize data for writing '''
        fmt = self._get_packing_fmt()
        args = self._get_packing_args()
        result = struct.pack(fmt, *args)
        return result

    def _deserialize(self, data):
        ''' Initialize values from data returned by struct.unpack()'''
        self.header_ = std_msgs/msg/Header_.std_msgs.msg.dds_.Header_()._deserialize(data)
        self.format_ = ddsutil._ptr_to_bytes(data.pop(0)).decode('ISO-8859-1')
        self.data_ = ddsutil._deserialize_seq(data, 'B', lambda seq_data: seq_data.pop(0))
        return self;

    def _get_packing_args(self):
        ''' Return an list of data suitable for struct.pack '''
        args = []
        args.extend(self.header_._get_packing_args())
        args.append(ddsutil._bytes_to_ptr(self.format_.encode('ISO-8859-1')))
        args.extend(ddsutil._serialize_seq(self.data_, 'B', lambda seq_args, v: seq_args.append(v)))
        return args

